﻿// Copyright © 2012 Fabio Marinelli, http://www.dudecat.com/

// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 


(function ($) {
    $.fn.parallax = function (options) {
        var opts = $.extend({}, $.fn.parallax.defaults, options);
        var elColl = $(this);
        var ww = $(window).width();
        var wh = $(window).height();
        var widthCenter = (ww / 2);
        var heightCenter = (wh / 2);
        var maxDepth = GetMaxDepth();
        var effectEnphatization = opts.emphasize;
        SetInitialPositions();

        $(document).mousemove(function (e) {
            var witdhMovement = (e.pageX - widthCenter);
            var heightMovement = (e.pageY - heightCenter);

            return elColl.each(function () {

                var el = $(this);
                if (el.data('par-fixed') != true) {
                    var distanceFromBg = maxDepth - el.data('par-depth');
                    var widthIncrease = witdhMovement * distanceFromBg / maxDepth;
                    var heightIncrease = heightMovement * distanceFromBg / maxDepth;
                    el.css('top', el.data('top') - heightIncrease * effectEnphatization / 100);
                    el.css('left', el.data('left') - widthIncrease * effectEnphatization / 100);
                    el.css('z-index', distanceFromBg + 1);
                }
            });
        });


        function GetMaxDepth() {
            var maxDepth = 0;
            elColl.each(function () {
                var el = $(this);
                if (el.data('par-fixed') == true && $(this).data('par-depth') > maxDepth) {
                    maxDepth = $(this).data('par-depth');
                }
            });
            return maxDepth;
        }

        function SetInitialPositions() {
            elColl.each(function () {
                var el = $(this);
                var position = el.position();
                el.data('top', position.top);
                el.data('left', position.left);
            });
        }

    };

    $.fn.parallax.defaults = { emphasize: 100 }
})(jQuery);