/* eslint-disable */
angular
  .module('App', [])
  .service('getTrans', function getTrans($http) {

    const getUrlParameter = (name) => {
      name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
      const regex = new RegExp(`[\\?&]${name}=([^&#]*)`);
      const results = regex.exec(document.location.search);
      return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
    };

    let lang = getUrlParameter('lang') || 'en';
    lang = !!~['en', 'ru', 'ge', 'pl', 'tr', 'ua', 'bg', 'sv', 'de', 'hr', 'fi', 'da', 'nn', 'ua'].indexOf(lang) ? lang : 'en';
    this.getList = $http.get(`./translations/${lang}.json`);
  })
  .controller('mainBody', function mainBody($scope, getTrans) {
    getTrans.getList.then(res => {
      $scope.t = res.data;

      // Loop through the winners
      (function winnerRotation() {
        var step = 4000;
        window.animationOffset = 250;
        setTimeout(() => { $('#winnersImageDP').fadeOut(animationOffset)}, step);
        setTimeout(() => { $('#winnersImageIR').fadeIn(animationOffset)}, step += window.animationOffset);
        setTimeout(() => { $('#winnersCaption').html(`${$scope.t.winnerName1} <span>${$scope.t.winWord}</span> ${$scope.t.winnerJackpot1} <br class=visible-xs-block /> ${$scope.t.winnerJackpot2}`)}, step);
        setTimeout(() => { $('#winnersImageIR').fadeOut(window.animationOffset)}, step += step);
        setTimeout(() => { $('#winnersImageGM').fadeIn(window.animationOffset)}, step += window.animationOffset);
        setTimeout(() => { $('#winnersCaption').html(`${$scope.t.winnerName2} <span>${$scope.t.winWord}</span> ${$scope.t.winnerJackpot3} <br class=visible-xs-block /> ${$scope.t.winnerJackpot4}`)}, step);
        setTimeout(() => { $('#winnersImageGM').fadeOut(window.animationOffset)}, step += step);
        setTimeout(() => { $('#winnersImageDP').fadeIn(window.animationOffset)}, step += window.animationOffset);
        setTimeout(() => { $('#winnersCaption').html(`${$scope.t.winnerName3} <span>${$scope.t.winWord}</span> ${$scope.t.winnerJackpot5} <br class=visible-xs-block /> ${$scope.t.winnerJackpot6}`)}, step);

        setTimeout(winnerRotation, step);
      })();

      // Makes page scroll to spinning wheel
      $("#scrollBtn").click(function () {
        $("html, body").animate({
          scrollTop: $('#spinBtn').offset().top
        }, 1000);
      });

      // Each spin produces a different result, needs a counter
      var spinCount = 0;

      // Makes wheel scrolls
      $("#spinBtn").click(function () {
        if (spinCount == 0) {
          $(".slot-machine__reel-1").css("margin-top", "-9852px");
          $(".slot-machine__reel-2").css("margin-top", "-9713px");
          $(".slot-machine__reel-3").css("margin-top", "-9643px");
        setTimeout(() => { $('#spinBtn').html(`${$scope.t.spinLoseButton}`)}, 3000);
        setTimeout("$('#spinRemainder').show(1000);", 3000);
          //                 setTimeout("$('html, body').animate({ scrollTop: '2000' });", 4000);
        } else if (spinCount == 1) {
          $('#spinRemainder').hide(1000);
          setTimeout("$('#remainderCount').html('4');", 1001);

          $(".slot-machine__reel-1").css("margin-top", "-4688px");
          $(".slot-machine__reel-2").css("margin-top", "-4616px");
          $(".slot-machine__reel-3").css("margin-top", "-4544px");

          setTimeout("$('#spinRemainder').show(1000);", 3000);
          //                 setTimeout("$('html, body').animate({ scrollTop: '2000' });", 4000);
        } else if (spinCount == 2) {
          $('#spinRemainder').hide(1000);

          $(".slot-machine__reel-1").css("transition", "margin-top 4s");
          $(".slot-machine__reel-2").css("transition", "margin-top 3s");
          $(".slot-machine__reel-3").css("transition", "margin-top 7s");

          $(".slot-machine__reel-1").css("margin-top", "-295px");
          $(".slot-machine__reel-2").css("margin-top", "-295px");
          $(".slot-machine__reel-3").css("margin-top", "-295px");

          // Then fade the slot area out, and put the survey in
          setTimeout(function () {
            $('#btn-win').click();
          }, 8500);

          /*
                          setTimeout("$('.jackpot').fadeOut(250);", 8000);
                          setTimeout("$('.survey').fadeIn(250);", 8250);

                          // Change the text in the red bar
                          setTimeout("$('#scrollBtn').html('Congratulations! You’ve won 150 chances for just $10!');", 8250);
          */
        }

        spinCount++;
      });

      // Fading things in and out when survey choice clicked
      $(".btn-question-1").click(function () {
        $("#question-1").fadeOut(0);
        $("#question-2").fadeIn(500);
      });
      $(".btn-question-2").click(function () {
        $("#question-2").fadeOut(0);
        $("#question-3").fadeIn(500);
      });
      $(".btn-question-3").click(function () {
        $("#question-3").fadeOut(0);
        $("#question-4").fadeIn(500);
      });
      $(".btn-question-4").click(function () {
        $("#question-4").fadeOut(0);

        // Starts the 'loading' sequence
        $(".loading").fadeIn(0);

        // Checks messages.
        setTimeout(function () { $("#check1").fadeIn(1000); }, 3000);
        setTimeout(function () { $("#check2").fadeIn(1000); }, 4500);
        setTimeout(function () { $("#check3").fadeIn(1000); }, 6000);

        // Removes loading and adds CTA
        setTimeout(function () { $(".loading").fadeOut(); }, 7500);
        setTimeout(function () { $(".cta").fadeIn(); }, 7500);
      });

    });
  });
